<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Franquicias</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear una Franquicia?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col
            v-for="(franquicia, indexFranquicia) in franquicias"
            :key="indexFranquicia"
            :xs="12"
            :sm="12"
            :md="6"
            :lg="3"
          >
            <v-card class="generalCard pa-4">
              <div>
                <v-btn
                  x-small
                  class="float-left"
                  text
                  icon
                  @click="
                    (dialogDelete = true), (franquicia_delete = franquicia)
                  "
                >
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/delete.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
                <v-btn
                  :to="franquicia.to"
                  x-small
                  class="float-right"
                  text
                  icon
                >
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/icoEditar.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
              </div>
              <v-card-text>
                <div class="cardFranqName cardFranqNameLine">
                  {{ franquicia.descripcion }}
                </div>
                <div class="cardCreacion">
                  <div>
                    Fecha de creación:
                    {{
                      moment(franquicia.fecha_creacion).format("DD / MM / YYYY")
                    }}
                  </div>
                  <div>
                    Creado por:
                    {{
                      serviceCommons.titleCase(
                        franquicia.empleado_crea.nombre_usuario
                      )
                    }}
                  </div>
                </div>
                <div
                  class="cardModificacion"
                  v-if="franquicia.empleado_modifica"
                >
                  <div>
                    <b>
                      Fecha de última modificación:
                      {{
                        moment(franquicia.fecha_modificacion).format(
                          "DD / MM / YYYY"
                        )
                      }}
                    </b>
                  </div>
                  <div>
                    <b>
                      Modificado por:
                      {{
                        serviceCommons.titleCase(
                          franquicia.empleado_modifica.nombre_usuario
                        )
                      }}
                    </b>
                  </div>
                </div>
                <v-footer absolute class="CardCustomAction">
                  <v-col>
                    <v-btn
                      :to="franquicia.to_modelos"
                      class="ma-2"
                      dark
                      tile
                      depressed
                      color="primary"
                      >Gestionar Modelos</v-btn
                    >
                  </v-col>
                </v-footer>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddFranquicia.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddFranquicia.to"
            :color="cardAddFranquicia.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddFranquicia.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddFranquicia.src"
                :lazy-src="cardAddFranquicia.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
        <v-col :key="cardAddNegocio.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddNegocio.to"
            :color="cardAddNegocio.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddNegocio.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddNegocio.src"
                :lazy-src="cardAddNegocio.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar esta franquicia?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: savingFranquicia }]"
                  @click="eliminarFranquicia"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog
          v-model="dialogDeleteConfirmacion"
          persistent
          max-width="700px"
        >
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar esta franquicia?</strong>
              </div>
              <div class="pa-4">
                La franquicia
                <strong>{{
                  franquicia_delete ? franquicia_delete.descripcion : ""
                }}</strong>
                tiene los siguientes modelos asignados:
                <br />

                <v-chip
                  v-for="(modelo, indexModelo) in modelos_franquicias"
                  :key="indexModelo"
                  class="ma-2"
                  >{{ modelo.nombre_modelo }}</v-chip
                >
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDeleteConfirmacion = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: savingFranquicia }]"
                  @click="deleteFranquicia(franquicia_delete)"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import Vuex from "vuex";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-GestionarFranquicias",
  data() {
    return {
      moment: moment,
      franquicia_delete: null,
      dialogDelete: false,
      dialogDeleteConfirmacion: false,
      pendingModelos: true,
      modelos_franquicias: null,
      savingFranquicia: false,
      cardAddFranquicia: {
        title: "Crear Franquicia",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nueva franquicia a la lista.",
        to: {
          name: "modelo_franquicia_franquicias_nueva"
        },
        color: "#494949"
      },
      cardAddNegocio: {
        title: "Gestionar Negocio",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade un nuevo negocio a la lista.",
        to: {
          name: "modelo_franquicia_catalogos_negocios"
        },
        color: "#494949"
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Franquicias",
          disabled: true
        }
      ],
      btoa: function(str) {
        str = JSON.stringify(str);
        return window.btoa(unescape(encodeURIComponent(str)));
      },
      franquicias: []
    };
  },
  filters: {
    dateFormat: function(value) {
      if (!value) return "";
      value = value.toString();
      return moment(value.format("MM/DD/YYYY"));
    }
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    getFranquicias() {
      var self = this;
      axios
        .get("/franquicia/secure/get/")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFranquicias(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFranquicias(data) {
      if (data) {
        data.forEach((itemFranquicia) => {
          itemFranquicia.to_modelos = {
            name: "modelo_franquicia_franquicias_franquicia_modelo",
            params: {
              franquicia: this.serviceCommons.objectToBase64(itemFranquicia)
            }
          };
          itemFranquicia.to = {
            name: "modelo_franquicia_franquicias_edicion",
            params: {
              franquicia: this.serviceCommons.objectToBase64(itemFranquicia)
            }
          };
        });
        this.franquicias = data;
      }
    },
    getModelos(franquicia) {
      var self = this;
      axios
        .get("/modelos/franquicia/secure/get/" + franquicia.id_franquicia)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.modelos_franquicias = data;
                self.dialogDeleteConfirmacion = true;
              } else {
                self.deleteFranquicia(self.franquicia_delete);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.dialogDelete = false;
          self.savingFranquicia = false;
        });
    },

    deleteFranquicia(franquicia) {
      var self = this;
      franquicia.id_empleado_modifica = user.empleado;
      franquicia.id_status = 2;
      axios
        .delete("/franquicia/secure/delete", { data: franquicia })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.eliminaFranquiciaArray(franquicia);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.savingFranquicia = false;
        });
    },
    eliminarFranquicia() {
      this.getModelos(this.franquicia_delete);
      this.savingFranquicia = true;
    },
    eliminaFranquiciaArray(franquicia) {
      let indexNegocioOut = 0;

      this.franquicias.forEach((itemFranquicia, indexFranquicia) => {
        if (itemFranquicia.id_franquicia == franquicia.id_franquicia) {
          indexNegocioOut = indexFranquicia;
        }
      });

      this.franquicias.splice(indexNegocioOut, 1);
      this.dialogDeleteConfirmacion = false;
      this.dialogDelete = false;
    }
  },
  created() {
    this.getFranquicias();
  }
};
</script>
